function [ff w0 m0 s0] = cnratio2cn(w, MaxFunEvals,MaxIter)

if nargin <2
    MaxFunEvals=1e4;
end
if nargin <3
    MaxIter=5e3;
end

global v0
v0 = w;
nonNaN_idx = find(~isnan(v0));
v0 = v0(nonNaN_idx);

base_line = log2([.5;1;1.5;2]);
mc = length(base_line);

sh = 0;
w = ones(mc,1)/mc;
s = ones(mc,1)*std(v0)/sqrt(mc);

x0 = [sh;log(w);s];
opt = optimset('MaxFunEvals',MaxFunEvals,'MaxIter',MaxIter);%,'display','iter');
theta = fminsearch(@fun_mix_cnv,x0,opt);
shift = theta(1);
m0 = base_line+shift;
w0 = exp(theta(2:1+mc));
w0 = w0/sum(w0);
s0 = theta(2+mc:1+2*mc);
[sv sp] = sort(m0);
m0 = m0(sp);
w0 = w0(sp);
s0 = s0(sp);

ff = zeros(length(w),mc);
ff(ff==0) = NaN;
for i=1:mc
    ff(nonNaN_idx,i) = w0(i)*normpdf(v0,m0(i),s0(i));
end
ff = ff./repmat(sum(ff,2),1,mc);

